/*
  backbone-pageable
  http://github.com/wyuenho/backbone-pageable

  Copyright (c) 2012 Jimmy Yuen Ho Wong
  Licensed under the MIT @license.
*/
(function(e){if("object"==typeof exports)module.exports=e(require("underscore"),require("backbone"));else if("function"==typeof define&&define.amd)define(["underscore","backbone"],e);else if("undefined"!=typeof _&&"undefined"!=typeof Backbone){var t=Backbone.PageableCollection,r=Backbone.PageableCollection=e(_,Backbone);Backbone.PageableCollection.noConflict=function(){return Backbone.PageableCollection=t,r}}})(function(e,t){"use strict";function r(t,r){if(t*=1,!e.isNumber(t)||e.isNaN(t)||!e.isFinite(t)||~~t!==t)throw new TypeError("`"+r+"` must be a finite integer");return t}function a(){var t=arguments[0],r=e.toArray(arguments).slice(1),a=t.comparator;t.comparator=null;try{t.reset.apply(t,r)}finally{t.comparator=a,a&&t.sort()}return t}var i=/[\s'"]/g,s=/[<>\s'"]/g,n=t.Collection.extend({state:{firstPage:1,lastPage:null,currentPage:null,pageSize:25,totalPages:null,totalRecords:null,sortKey:null,order:-1},mode:"server",queryParams:{currentPage:"page",pageSize:"per_page",totalPages:"total_pages",totalRecords:"total_entries",sortKey:"sort_by",order:"order",directions:{"-1":"asc",1:"desc"}},initialize:function(t,r){r=r||{};var a=this.mode=r.mode||this.mode||o.mode,i=e.extend({},o.queryParams,this.queryParams,r.queryParams||{});i.directions=e.extend({},o.queryParams.directions,this.queryParams.directions,i.directions||{}),this.queryParams=i;var s=this.state=e.extend({},o.state,this.state,r.state||{});s.currentPage=null==s.currentPage?s.firstPage:s.currentPage,this.switchMode(a,e.extend({fetch:!1,resetState:!1,models:t},r));var n=r.comparator;if(s.sortKey&&!n&&this.setSorting(s.sortKey,s.order,r),"client"!=a||null!=s.totalRecords||e.isEmpty(t)||(s.totalRecords=t.length),this.state=this._checkState(s),"server"!=a){if(n&&r.full){delete this.comparator;var l=this.fullCollection;l.comparator=n,l.sort()}t&&!e.isEmpty(t)&&(this.getPage(s.currentPage),t.splice.apply(t,[0,t.length].concat(this.models)))}this._initState=e.clone(this.state)},_makeFullCollection:function(r,a){var i,s,n,o=["url","model","sync","comparator"],l=this.constructor.prototype,c={};for(i=0,s=o.length;s>i;i++)n=o[i],e.isUndefined(l[n])||(c[n]=l[n]);var u=new(t.Collection.extend(c))(r,a);for(i=0,s=o.length;s>i;i++)n=o[i],this[n]!==l[n]&&(u[n]=n);return u},_makeCollectionEventHandler:function(t,r){return function i(s,n,o,l){t.off("all",i),r.off("all",i);var c=e.clone(t.state),u=c.firstPage,h=0===u?c.currentPage:c.currentPage-1,f=c.pageSize,d=h*f,g=d+f;if("add"==s){var m,p,P;if(o==r)m=r.indexOf(n),m>=d&&g>m&&(P=t,p=m-d);else{m=d+t.indexOf(n),P=r;var v=l&&l.at||m;p=d>v||v>=g?v:m}P&&(P.add(n,e.extend({},l||{},{at:p})),t.pop()),c.totalRecords++}if("remove"==s){var y;if(o==t?(y=r.at(g),y&&t.push(y),r.remove(n)):l.index>=d&&g>l.index&&(t.remove(n),y=r.at(h*(f+l.index)),y&&t.push(y)),--c.totalRecords){var k=c.totalPages=Math.ceil(c.totalRecords/f);c.lastPage=0===u?k-1:k,c.currentPage>k&&(c.currentPage=c.lastPage)}else c.totalRecords=null,c.totalPages=null}if("reset"==s||"sort"==s){if(l=o,o=n,o==t&&"reset"==s){var b=r.models.slice(0,d),x=r.models.slice(d+t.models.length);a(r,b.concat(t.models).concat(x)),l=e.extend(l,{silent:!0})}("reset"==s||o==r)&&(a(t,r.models.slice(d,g),l),c.totalRecords=r.models.length)}t.state=t._checkState(c),t.on("all",i),r.on("all",i)}},_checkState:function(e){var t=e.totalRecords,a=e.pageSize,i=e.currentPage,s=e.firstPage,n=e.totalPages;if(null!=t&&null!=a&&null!=i&&null!=s){if(t=r(t,"totalRecords"),a=r(a,"pageSize"),i=r(i,"currentPage"),s=r(s,"firstPage"),1>a)throw new RangeError("`pageSize` must be >= 1");if(n=e.totalPages=Math.ceil(t/a),0===s){if(s>i||i>=n)throw new RangeError("`currentPage` must be firstPage <= currentPage < totalPages if 0-based.")}else{if(1!==s)throw new RangeError("`firstPage must be 0 or 1`");if(s>i||i>n)throw new RangeError("`currentPage` must be firstPage <= currentPage <= totalPages if 1-based.")}e.lastPage=0===s?n-1:n}return e},setPageSize:function(t,a){return t=r(t,"pageSize"),a=a||{},this.state=this._checkState(e.extend({},this.state,{pageSize:t,totalPages:"client"==this.mode?Math.ceil(this.fullCollection.size()/t):Math.ceil(this.state.totalRecords/t)})),this.getPage(this.state.currentPage,a)},switchMode:function(t,r){if(!e.contains(["server","client","infinite"],t))throw new TypeError('`mode` must be one of "server", "client" or "infinite"');r=r||{fetch:!0,resetState:!0},this.state=r.resetState?e.clone(this._initState):this._checkState(e.extend({},this.state)),this.mode=t;var a=this.fullCollection,i=this._eh;if("server"==t||a?"server"==t&&a&&(a.off("all",i),this.off("all",i),this._fullComparator=a.comparator,delete this.fullCollection):(a=this.fullCollection=this._makeFullCollection(r.models||[]),i=this._eh=this._makeCollectionEventHandler(this,a),a.on("all",i),this.on("all",i),a.comparator=this._fullComparator),"infinite"==t){var s=this.url;this.links={first:s,current:s},this.links[this.state.currentPage]=s}else this.links&&delete this.links;return r.fetch?this.fetch(e.omit(r,["fetch","resetState"])):this},getFirstPage:function(e){return this.getPage("first",e)},getPreviousPage:function(e){return this.getPage("prev",e)},getNextPage:function(e){return this.getPage("next",e)},getLastPage:function(e){return this.getPage("last",e)},getPage:function(t,a){a=a||{fetch:!1};var i=this.state,s=i.firstPage,n=i.currentPage,o=i.lastPage,l=i.pageSize,c=t;switch(t){case"first":c=s;break;case"prev":c=n-1;break;case"next":c=n+1;break;case"last":c=o;break;default:c=r(t,"index")}this.state=this._checkState(e.extend({},i,{currentPage:c}));var u=this.mode,h=("client"==u||"infinite"==u&&n>=c&&this.fullCollection.length)&&!a.fetch;if(h){var f=(0===s?c:c-1)*l,d=f+l;return this.reset(this.fullCollection.models.slice(f,d),e.omit(a,"fetch"))}if("infinite"==u){var g=this.links;if(!g[t])throw new TypeError("No link found for '"+t+"'");var m=g.current=g[c]=g[t];a.fetch&&(a.url=m);var p=this.fullCollection,P=this;return this.fetch(e.extend({url:m,add:!0,update:!0,remove:!1,at:p.length},e.omit(a,"fetch"))).done(function(t,r,a){return e.extend(P.links,P.parseLinks(t,{xhr:a})),P.reset(p.models.slice(f,d))})}return this.fetch(e.omit(a,"fetch"))},parseLinks:function(t,r){var a=r.xhr.getResponseHeader("Link"),n=["first","prev","previous","next","last"],o={};return e.each(a.split(","),function(t){var r=t.split(";"),a=r[0].replace(s,""),l=r.slice(1);e.each(l,function(t){var r=t.split("="),s=r[0].replace(i,""),l=r[1].replace(i,"");"rel"==s&&e.contains(n,l)&&("previous"==l?o.prev=a:o[l]=a)})}),o},parse:function(t){if(!e.isArray(t))return new TypeError("The server response must be an array");if(2===t.length&&e.isObject(t[0])&&e.isArray(t[1])){var r=this.queryParams,a=e.clone(this.state),i=t[0];return e.each(e.pairs(e.omit(r,"directions")),function(e){var t=e[0],r=e[1];a[t]=i[r]}),i.order&&(a.order=1*e.invert(r.directions)[i.order]),this.state=this._checkState(a),t[1]}return t},fetch:function(r){r=r||{};var a=r.data=r.data||{},i=this.mode;if("infinite"==i&&!r.url)return this.getPage(this.state.currentPage,{fetch:!0});var s,n,l,c,u=this._checkState(this.state),h="client"==this.mode?e.pick(this.queryParams,"sortKey","order"):e.omit(e.pick(this.queryParams,e.keys(o.queryParams)),"directions"),f=e.pairs(h),d=e.clone(this);for(s=0;f.length>s;s++)n=f[s],l=n[0],c=n[1],c=e.isFunction(c)?c.call(d):c,null!=u[l]&&null!=c&&(a[c]=u[l]);u.sortKey&&u.order?a[h.order]=this.queryParams.directions[u.order+""]:u.sortKey||delete a[h.order];var g=e.pairs(e.omit(this.queryParams,e.keys(o.queryParams)));for(s=0;g.length>s;s++)n=g[s],c=n[1],c=e.isFunction(c)?c.call(d):c,a[n[0]]=c;var m=this.fullCollection,p=t.Collection.prototype;if("client"==i){var P=r.success;return r.success=function(e,t,a){a=a||{},a.silent=r.silent,m.reset(e.models,a),P&&P(e,t,a)},p.fetch.call(this,e.extend({},r,{silent:!0}))}return p.fetch.call(this,r)},_makeComparator:function(e,t){var r=this.state;return e=e||r.sortKey,t=t||r.order,e&&t?function(r,a){var i,s=r.get(e),n=a.get(e);return 1===t&&(i=s,s=n,n=i),s===n?0:n>s?-1:1}:void 0},setSorting:function(t,r,a){var i=this.state;i.sortKey=t,i.order=r=r||i.order;var s=this.fullCollection,n=!1,o=!1;t||(n=o=!0);var l=this.mode;a=e.extend({side:"client"==l?l:"server",full:!0},a);var c=this._makeComparator(t,r),u=a.full,h=a.side;return"client"==h?u?(s&&(s.comparator=c),n=!0):(this.comparator=c,o=!0):"server"!=h||u||(this.comparator=c),n&&delete this.comparator,o&&s&&delete s.comparator,this}}),o=n.prototype;return n});